﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="BPMNShapes.aspx.cs" Inherits="WebApplication2.BPMNShapes" %>

<%@ Register Assembly="Syncfusion.EJ.Web" Namespace="Syncfusion.JavaScript" TagPrefix="ej" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <link href="themes/default-theme/ej.widgets.all.min.css" rel="stylesheet" />   
    <script src="scripts/jquery-1.10.2.min.js"></script>
    <script src="scripts/jquery.easing.1.3.min.js"></script>
    <script src="scripts/jquery.globalize.min.js"></script>
    <script src="scripts/jsrender.min.js"></script>
    <script src="Scripts/ej.web.all.min.js"></script>    

    <input type="button" value="orthogonal" onclick="orthogonaltool()" />
 
     <script type="text/javascript">
         var diagram = $("#Diagram1").ejDiagram("instance");
        
         function orthogonaltool() {
             var diagram = $("#Diagram1").ejDiagram("instance");
             diagram.model.drawType = {
                 type: "orthogonalLine",
             };
             diagram.update({
                 tool: ej.datavisualization.Diagram.Tool.DrawOnce
             })
         }

         function selectionchanged(args) {              
             hidehandles(args);
         }

         function drop(args) {              
             hidehandles(args);
         }

         function hidehandles(args) {
             var diagram = $("#Diagram1").ejDiagram("instance");
             var handles = diagram.model.selectedItems.userHandles;
             if (handles && args.element) {                 
                 if (args.element && (args.element.isSwimlane || args.element.isLane || args.element.type=="phase")) {
                     for (var i = 0; i < handles.length; i++) {
                         handles[i].visible = false;
                     }
                     diagram.updateUserHandles(args.element);
                 }
                 else {
                     for (var i = 0; i < handles.length; i++) {
                         handles[i].visible = true;
                     }
                 }
             }
         }

         function ShowHandles(diagram, args) {
             var handles = diagram.model.selectedItems.userHandles;
           
             for (var i = 0; i < handles.length; i++) {
                 if (args.element && (args.element.isSwimlane || args.element.isLane || args.element.type == "phase")) {
                     handles[i].visible = false;
                 }
                 else {
                     handles[i].visible = true;
                 }
             }
                          
         }

        
         var userHandles = [];
         userHandles = createUserHandles();
 
         $(window).load(function () {
             var diagram = $("#Diagram1").ejDiagram("instance");
             diagram.model.selectedItems.userHandles = createUserHandles(userHandles);
             diagram._initHandles();        
         });

         function createUserHandles() {
             var diagram = $("#Diagram1").ejDiagram("instance");
             var LinkTool = (function (base) {
                 var node = null;
                 var targetNode = null;
                 ej.datavisualization.Diagram.extend(LinkTool, base);
                 function LinkTool(name) {
                     base.call(this, name);
                     this.singleAction = true;
                     this.cursor = "pointer";
                     return this;
                 }
                 LinkTool.prototype.mousedown = function (evt) {
                     node = this.diagram.selectionList[0];
                     this._currentPossibleConnection = node;
                     //    this._possibleConnectionPort = node.ports[0];
                     base.prototype.mousedown.call(this, evt);
                     this._showAllPorts();
                     this.diagram.addSelection(node);
                     this._sourcePossibleConnection = node;
                     targetNode = null;
                 };

                 LinkTool.prototype.mouseup = function (evt) {
                     if (evt.target.id == "Line_shape") {
                         this.inAction = false;
                         this.diagram._clearSelection();
                         if (this.helper)
                             this.diagram._remove(this.helper);
                         this.helper = null;
                         this.svgHelper = null;
                         base.prototype.mouseup.call(this, evt);
                         this.diagram.deactivateTool();
                         this.diagram.activateTool("orthogonalLine", true);
                     }
                     else {
                         if (this._sourcePossibleConnection && this._sourcePossibleConnection.ports.length > 0)
                             if (!this._targetPossibleConnection) {
                                 if (!this._targetPort) {
                                     var dNode = this._createDynamicNode(node);
                                     this.diagram.add(dNode);
                                     this._targetPossibleConnection = this.diagram.nameTable[dNode.name];
                                     //this._targetPort = dNode.ports[0];
                                 }
                             }
                         targetNode = this._targetPossibleConnection.name;
                         this.diagram._updateEdges(this);
                         this._showAllPorts(true);
                         base.prototype.mouseup.call(this, evt);
                     }

                     if (targetNode) {
                         this.diagram._clearSelection();
                         //    this.diagram.selectionList.add(this._targetPossibleConnection)
                         this.diagram.addSelection(targetNode)
                     }

                 };

                 LinkTool.prototype._createDynamicNode = function (node) {
                     var node = $.extend(true, {}, node);
                     node.outEdges = [];
                     node.inEdges = [];
                     node.offsetX = this.currentPoint.x;
                     node.offsetY = this.currentPoint.y;
                     node.name = node.name + ej.datavisualization.Diagram.Util.randomId();
                     return node;
                 };
                 return LinkTool;
             })(ej.datavisualization.Diagram.OrthogonalLineTool);

             var linkHandle = ej.datavisualization.Diagram.UserHandle();
             linkHandle.name = "Line";

             linkHandle.position = ej.datavisualization.Diagram.UserHandlePositions.MiddleRight;
             linkHandle.visible = true;

             linkHandle.tool = new LinkTool(linkHandle.name);
             linkHandle.size = 30;
             linkHandle.backgroundColor = "#4D4D4D";
             linkHandle.pathData = "M196.2104,93.6494L196.2104,90.2544L189.1674,90.2544L189.1674,87.6694L196.2104,87.6694L196.2104,84.7344L200.6674,89.1914z";
             userHandles.push(linkHandle);
             return userHandles;
         }

      
    </script>
    
</head>
<body>
    <form id="form1" runat="server">
        <div id="main-left" style="height: 700px; width: 270px; float: left">
            <ej:SymbolPalette ID="symbolpalette" runat="server">
            </ej:SymbolPalette>
        </div>
        <div id="main-right">
            <asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
            <ej:Diagram ID="Diagram1" runat="server" Height="900px" Width="1000px" OnClientConnectionChange="ConnectionChange" OnClientRotationChange="RotationChange" OnClientSelectionChange="selectionchanged" OnClientDrop="drop">
            </ej:Diagram>
        </div>
 
    </form>
   
</body>
</html>
